echo OFF
echo "twsConfigAction****************"


echo "TWS home dir %1%"
echo "TWS Action Tools %2%"
echo "TWS user name %3%"
echo "TWS domain name %4%"
echo "pwd %5%"
echo "this_cpu %6%"
echo "master_cpu %7%"
echo "computer_name %8%"
echo "agent %9%"

SET TWS_HOME=%~1%
SET ACTIONTOOLSDIR=%~2%
SET tws_user=%~3%
SET domain=%~4%
SET pwd=%~5%
SET this_cpu=%~6%
SET master_cpu=%~7%
SET computer_name=%~8%
SET agent=%~9%
SET VERBOSE="-verbose"

SET STATUSDIR=%TWS_HOME%\_uninstall\ACTIONTOOLS

rem call %TWS_HOME%\tws_env.cmd
set PATH=%TWS_HOME%;%TWS_HOME%\bin;%PATH%
set TWS_TISDIR=%TWS_HOME%

echo "STATUS FILES"
dir %STATUSDIR%\*.historyFile


rem INSTALL: ISTANCE UPDATE CONFIG FILES ACTION (NOT NEED UNDO) *****
call "%ACTIONTOOLSDIR%\wintoposix.exe" "%TWS_HOME%"
if not %errorlevel%==0 echo "wintoposix.exe"&&exit %errorlevel%



rem Creating Security file to use for TWS Security file creation
rem Scenario Fresh: YES
rem Scenario Upgrade: YES
rem Scenario Promote: YES
rem Scenario Patch: NO

IF NOT EXIST %STATUSDIR%\FLOW_PATCH.historyFile (
if "%agent%" == "MDM" (
echo "changing names..."
IF EXIST %STATUSDIR%\FLOW_PROMOTE.historyFile set master_cpu=%this_cpu%
IF EXIST %STATUSDIR%\FLOW_FRESH.historyFile set this_cpu=%master_cpu%
echo "this_cpu %6%"
echo "master_cpu %7%"


IF EXIST %TWS_HOME%\userdef_wnt del /F /Q %TWS_HOME%\userdef_wnt

echo username %tws_user% > %TWS_HOME%\userdef_wnt
if not %errorlevel%==0 echo "updating userdef_wnt"&&exit %errorlevel%
echo password "%pwd%" >> %TWS_HOME%\userdef_wnt
if not %errorlevel%==0 echo "updating userdef_wnt"&&exit %errorlevel%
echo end >> %TWS_HOME%\userdef_wnt
if not %errorlevel%==0 echo "updating userdef_wnt"&&exit %errorlevel%
echo username %domain%\%tws_user% >> %TWS_HOME%\userdef_wnt
if not %errorlevel%==0 echo "updating userdef_wnt"&&exit %errorlevel%
echo password "%pwd%" >> %TWS_HOME%\userdef_wnt
if not %errorlevel%==0 echo "updating userdef_wnt"&&exit %errorlevel%
echo end >> %TWS_HOME%\userdef_wnt
if not %errorlevel%==0 echo "updating userdef_wnt"&&exit %errorlevel%
echo username %master_cpu%_%tws_user% >> %TWS_HOME%\userdef_wnt
if not %errorlevel%==0 echo "updating userdef_wnt"&&exit %errorlevel%
echo password "%pwd%" >> %TWS_HOME%\userdef_wnt
if not %errorlevel%==0 echo "updating userdef_wnt"&&exit %errorlevel%
echo end >> %TWS_HOME%\userdef_wnt
if not %errorlevel%==0 echo "updating userdef_wnt"&&exit %errorlevel%

)
)

rem Updating TBSM binary in bin dir if TBSM has been configured for use
rem Scenario Fresh: NO
rem Scenario Upgrade: YES
rem Scenario Promote: YES
rem Scenario Patch: YES
IF EXIST %TWS_HOME%\bin\clagent.exe call copy /Y/A "%TWS_HOME%\Tbsm\clagent\bin\clagent.exe" "%TWS_HOME%\bin\clagent.exe"

rem Restore old TBSM config file
rem Scenario Fresh: NO
rem Scenario Upgrade: YES
rem Scenario Promote: YES
rem Scenario Patch: YES
IF EXIST "%TWS_HOME%\Tbsm\TbsmAdapter\adapter.config.bck" call copy /Y/A "%TWS_HOME%\Tbsm\TbsmAdapter\adapter.config.bck" "%TWS_HOME%\Tbsm\TbsmAdapter\adapter.config"


rem Create FTBOX directory
IF NOT EXIST "%TWS_HOME%\ftbox" call mkdir %TWS_HOME%\ftbox



rem Updating localopts globalopts with new keys
rem Scenario Fresh: NO
rem Scenario Upgrade: YES
rem Scenario Promote: NO
rem Scenario Patch: NO

IF EXIST %STATUSDIR%\FLOW_UPGRADE.historyFile (

rem Add a simple row to avoid end of files problems
call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\localopts" ""
call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\mozart\globalopts" ""


call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\localopts" "nm SSL port" "	0" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\localopts" "SSL key" "%TWS_HOME%/ssl/TWS.key" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\localopts" "SSL certificate" "%TWS_HOME%/ssl/TWS.crt" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\localopts" "SSL key pwd" "%TWS_HOME%/ssl/TWS.sth" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\localopts" "SSL CA certificate" "%TWS_HOME%/ssl/TWSTrustedCA.crt" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\localopts" "SSL certificate chain" "%TWS_HOME%/ssl/TWSCertificateChain.crt" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\localopts" "SSL random seed" "%TWS_HOME%/ssl/TWS.rnd" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\localopts" "SSL Encryption Cipher" " SSLv3" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\localopts" "SSL auth mode" " caonly" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\localopts" "SSL auth string" " tws" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\mozart\globalopts" "centralized security" " no" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\mozart\globalopts" "enable list security check" " no" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -addRow "%TWS_HOME%\mozart\globalopts" "enable switch fault tolerance" " no" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%

rem Copy old mozart database
IF EXIST "%TWS_HOME%\..\unison\network" (
echo "Exist old mozart database"
IF NOT EXIST "%TWS_HOME%\network\cpudata" call xcopy /Y/I "%TWS_HOME%\..\unison\network\*" "%TWS_HOME%\network"
)

)



rem INSTALL: ISTANCE UPDATE CONFIG FILES ACTION (NEED UNDO) *****
rem Scenario Fresh: YES
rem Scenario Upgrade: YES
rem Scenario Promote: YES
rem Scenario Patch: NO

IF NOT EXIST %STATUSDIR%\FLOW_PATCH.historyFile (
call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -updateProperty "%TWS_HOME%\mozart\globalopts" "master" "%master_cpu%" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%
call "%ACTIONTOOLSDIR%\TWSupdate_file.exe" -updateProperty "%TWS_HOME%\localopts" "thiscpu" "%this_cpu%" "%VERBOSE%"
if not %errorlevel%==0 echo "TWSupdate_file.exe"&&exit %errorlevel%
)



rem INSTALL: set file permissions
cd %TWS_HOME%
call %TWS_HOME%\bin\setown.cmd %TWS_HOME%


rem *** FIXPACK ONLY ***
rem Fixpack scenario has to skip from here
IF EXIST %STATUSDIR%\FLOW_PATCH.historyFile exit 0


rem Promote scenario has to skip services creation
IF EXIST %TWS_HOME%\_uninstall\ACTIONTOOLS\FLOW_PROMOTE.historyFile exit 0



rem INSTALL: autotrace installation
rem Scenario Fresh: YES
rem Scenario Upgrade: YES
rem Scenario Promote: NO
rem Scenario Patch: NO
call %TWS_HOME%\trace\atinstall.exe --quietcopy %TWS_HOME%\trace
if not %errorlevel%==0 echo "atinstall.exe"&&exit %errorlevel%



rem INSTALL: REGISTER NT SERVICES ACTION (NEED UNDO) *****
rem Scenario Fresh: YES
rem Scenario Upgrade: YES
rem Scenario Promote: NO
rem Scenario Patch: NO

if "%domain%" == "%computer_name%" goto noDomainParameter

rem NETMAN
call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -RegisterWinService "tws_netman_%domain%_%tws_user%" "Tivoli Netman (for %domain%\%tws_user%)" "%TWS_HOME%\bin\netman.exe" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%
rem TOKEN SERVER
call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -RegisterWinService "tws_tokensrv_%domain%_%tws_user%" "Tivoli Token Service (for %domain%\%tws_user%)" "%TWS_HOME%\bin\tokensrv.exe" "%domain%\%tws_user%" "%pwd%" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%
rem TIVOLI WORKLOAD SCHEDULER
call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -RegisterWinService "tws_maestro_%domain%_%tws_user%" "Tivoli Workload Scheduler (for %domain%\%tws_user%)" "%TWS_HOME%\bin\batchup.exe" "%domain%\%tws_user%" "%pwd%" "tws_tokensrv_%domain%_%tws_user%" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%

goto afterServiceCreation
:noDomainParameter

rem NETMAN
call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -RegisterWinService "tws_netman_%tws_user%" "Tivoli Netman (for %tws_user%)" "%TWS_HOME%\bin\netman.exe" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%
rem TOKEN SERVER
call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -RegisterWinService "tws_tokensrv_%tws_user%" "Tivoli Token Service (for %tws_user%)" "%TWS_HOME%\bin\tokensrv.exe" ".\%tws_user%" "%pwd%" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%
rem TIVOLI WORKLOAD SCHEDULER
call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -RegisterWinService "tws_maestro_%tws_user%" "Tivoli Workload Scheduler (for %tws_user%)" "%TWS_HOME%\bin\batchup.exe" ".\%tws_user%" "%pwd%" "tws_tokensrv_%tws_user%" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%

:afterServiceCreation




rem INSTALL: REGISTER NT REGISTRY KEYWORDS ACTION (NEED UNDO) *****
rem Scenario Fresh: YES
rem Scenario Upgrade: YES
rem Scenario Promote: NO
rem Scenario Patch: NO

call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -AddWinRegistryKey "SOFTWARE\IBM" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%
call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -AddWinRegistryKey "SOFTWARE\IBM\Tivoli Workload Scheduler" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%
call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -AddWinRegistryKey "SOFTWARE\IBM\Tivoli Workload Scheduler\8.2.1_%domain%_%tws_user%" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%
call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -AddWinRegistryKeyValue "SOFTWARE\IBM\Tivoli Workload Scheduler\8.2.1_%domain%_%tws_user%" "InstallDirectory" "%TWS_HOME%" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%
call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -AddWinRegistryKeyValue "SOFTWARE\IBM\Tivoli Workload Scheduler\8.2.1_%domain%_%tws_user%" "USERNAME" "%domain%\%tws_user%" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%
call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -AddWinRegistryKeyValue "SOFTWARE\IBM\Tivoli Workload Scheduler\8.2.1_%domain%_%tws_user%" "Version" "8.2.1" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%

rem Add Remove Programs key
IF NOT EXIST %STATUSDIR%\METHOD_CM.historyFile call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -AddWinRegistryKey "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\IBMTivoliWorkloadScheduler8.2.1(%domain%_%tws_user%)" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%
IF NOT EXIST %STATUSDIR%\METHOD_CM.historyFile call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -AddWinRegistryKeyValue "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\IBMTivoliWorkloadScheduler8.2.1(%domain%_%tws_user%)" "DisplayName" "IBM Tivoli Workload Scheduler 8.2.1 (%domain%\%tws_user%)" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%
IF NOT EXIST %STATUSDIR%\METHOD_CM.historyFile call "%ACTIONTOOLSDIR%\twsConfigAction.exe" -AddWinRegistryKeyValue "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\IBMTivoliWorkloadScheduler8.2.1(%domain%_%tws_user%)" "UninstallString" "%TWS_HOME%\twsRemove.cmd" "%VERBOSE%"
if not %errorlevel%==0 echo "twsConfigAction.exe"&&exit %errorlevel%

exit 0
