echo "twsUndoAction****************"
echo "TWS home dir %1%"
echo "TWS Action Tools %2%"
echo "TWS user name %3%"
echo "TWS domain name %4%"
echo "TWSREGISTRYFILE %5%"

SET TWS_HOME=%1%
SET ACTIONTOOLSDIR=%2%
SET tws_user=%3%
SET domain=%4%
SET TWSREGISTRYFILE=%5%
SET VERBOSE="-verbose"
SET STATUSDIR=%TWS_HOME%\_uninstall\ACTIONTOOLS

cd %TWS_HOME%

rem This script is called inside the SPB
rem while performing an undo or roll-back flow

echo "STATUS FILES"
dir %STATUSDIR%\*.historyFile


rem UNDO: REGISTER NT SERVICES ACTION *****
rem if NOT 8.2 UPGRADED
IF EXIST %STATUSDIR%\FLOW_FRESH.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_netman_%domain%_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\FLOW_FRESH.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_maestro_%domain%_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\FLOW_FRESH.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_tokensrv_%domain%_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\FLOW_FRESH.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_netman_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\FLOW_FRESH.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_maestro_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\FLOW_FRESH.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_tokensrv_%tws_user%" "%VERBOSE%"

IF EXIST %STATUSDIR%\8.1_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_netman_%domain%_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\8.1_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_maestro_%domain%_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\8.1_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_tokensrv_%domain%_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\8.1_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_netman_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\8.1_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_maestro_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\8.1_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_tokensrv_%tws_user%" "%VERBOSE%"

IF EXIST %STATUSDIR%\7.0_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_netman_%domain%_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\7.0_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_maestro_%domain%_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\7.0_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_tokensrv_%domain%_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\7.0_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_netman_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\7.0_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_maestro_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\7.0_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -DeregisterWinService "tws_tokensrv_%tws_user%" "%VERBOSE%"



rem UNDO: REGISTER NT REGISTRY KEYWORDS ACTION *****
rem if NOT 8.2 UPGRADED
IF EXIST %STATUSDIR%\FLOW_FRESH.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -CleanupRegistryKey "SOFTWARE\IBM\Tivoli Workload Scheduler\8.2.1_%domain%_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\FLOW_FRESH.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -CleanupRegistryKey "SOFTWARE\IBM\Tivoli Workload Scheduler\8.2.1_%tws_user%" "%VERBOSE%"

IF EXIST %STATUSDIR%\FLOW_UPGRADE.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -CleanupRegistryKey "SOFTWARE\IBM\Tivoli Workload Scheduler\8.2.1_%domain%_%tws_user%" "%VERBOSE%"
IF EXIST %STATUSDIR%\FLOW_UPGRADE.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -CleanupRegistryKey "SOFTWARE\IBM\Tivoli Workload Scheduler\8.2.1_%tws_user%" "%VERBOSE%"

rem Remove AddRemove Programs Key
IF EXIST %STATUSDIR%\FLOW_FRESH.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -CleanupRegistryKey "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\IBMTivoliWorkloadScheduler8.2.1(%domain%_%tws_user%)" "%VERBOSE%"
IF EXIST %STATUSDIR%\FLOW_UPGRADE.historyFile call %ACTIONTOOLSDIR%\twsConfigAction.exe -CleanupRegistryKey "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\IBMTivoliWorkloadScheduler8.2.1(%domain%_%tws_user%)" "%VERBOSE%"

rem TWSREGISTRY.DAT CLEANING *****
IF EXIST %STATUSDIR%\FLOW_FRESH.historyFile call %ACTIONTOOLSDIR%\TWSupdate_file.exe -delRow "%TWSREGISTRYFILE%" "/Tivoli/Workload_Scheduler/%tws_user%_DN" %VERBOSE%
IF EXIST %STATUSDIR%\8.1_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\TWSupdate_file.exe -delRow "%TWSREGISTRYFILE%" "/Tivoli/Workload_Scheduler/%tws_user%_DN" %VERBOSE%
IF EXIST %STATUSDIR%\7.0_DISCOVERY.historyFile call %ACTIONTOOLSDIR%\TWSupdate_file.exe -delRow "%TWSREGISTRYFILE%" "/Tivoli/Workload_Scheduler/%tws_user%_DN" %VERBOSE%

rem *** FIXPACK ONLY ***
rem SPB will execute this step
rem /Tivoli/Workload_Scheduler/$(tws_user)_DN_FixpackName=FP_TWS_NT_$(tws_user).8.2.0.$(patch_id)
rem IF EXIST %STATUSDIR%\FLOW_PATCH.historyFile call %ACTIONTOOLSDIR%\TWSupdate_file.exe -delRow "%TWSREGISTRYFILE%" "/Tivoli/Workload_Scheduler/%tws_user%_DN_FixpackName=FP_TWS_NT_%tws_user%.8.2.1.01" %VERBOSE%


rem RESTORE BACKUP FILES
IF EXIST "%TWS_HOME%\mozart\globalopts.bck" call copy /Y/A "%TWS_HOME%\mozart\globalopts.bck" "%TWS_HOME%\mozart\globalopts"
IF EXIST "%TWS_HOME%\localopts.bck" call copy /Y/A "%TWS_HOME%\localopts.bck" "%TWS_HOME%\localopts"
IF EXIST "%TWS_HOME%\Tbsm\TbsmAdapter\adapter.config.bck" call copy /Y/A "%TWS_HOME%\Tbsm\TbsmAdapter\adapter.config.bck" "%TWS_HOME%\Tbsm\TbsmAdapter\adapter.config"

rem ISMP created scripts
IF EXIST "%TWS_HOME%\twsRemove.bck" call copy /Y/A "%TWS_HOME%\twsRemove.bck" "%TWS_HOME%\twsRemove.cmd"



call del /F /Q %TWS_HOME%\*.old
call del /F /Q %TWS_HOME%\mozart\*.old
call del /F /Q %TWS_HOME%\*.bck
call del /F /Q %TWS_HOME%\mozart\*.bck
call del /F /Q %STATUSDIR%\*.historyFile


exit 0
